unit imagefxfrm;

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, dx_vgcore, dx_scene, dx_vglayer, dx_utils,
  dx_objects;

type
  TForm11 = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    Camera1: TdxCamera;
    PreviewLayer: TdxObjectLayer;
    Root4: TvxLayout;
    PreviewLayout: TvxLayout;
    Preview: TvxRectangle;
    ReflectionEffect1: TvxReflectionEffect;
    dragLayout: TvxRectangle;
    Rectangle1: TvxRectangle;
    Ellipse1: TvxEllipse;
    Line1: TvxLine;
    FloatKeyAnimation1: TvxFloatKeyAnimation;
    Text1: TvxText;
    Text3D1: TdxText3D;
    Light1: TdxLight;
    dxBitmapList1: TdxBitmapList;
    Dummy1: TdxDummy;
    Dummy2: TdxDummy;
    procedure dragLayoutDragOver(Sender: TObject;
      const Data: TvxDragObject; const Point: TvxPoint;
      var Accept: Boolean);
    procedure dragLayoutDragDrop(Sender: TObject;
      const Data: TvxDragObject; const Point: TvxPoint);
    procedure Text3D1DragOver(Sender: TObject; const Data: TdxDragObject;
      const Point: TdxPoint; var Accept: Boolean);
    procedure Text3D1DragDrop(Sender: TObject; const Data: TdxDragObject;
      const Point: TdxPoint);
    procedure dxScene1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure dxScene1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PreviewDragOver(Sender: TObject; const Data: TvxDragObject;
      const Point: TvxPoint; var Accept: Boolean);
  private
    { Private declarations }
    Down: TdxPoint;
  public
    { Public declarations }
  end;

var
  Form11: TForm11;

implementation

{$R *.dfm}


procedure TForm11.dragLayoutDragOver(Sender: TObject;
  const Data: TvxDragObject; const Point: TvxPoint; var Accept: Boolean);
begin
  Accept := true;
end;

procedure TForm11.dragLayoutDragDrop(Sender: TObject;
  const Data: TvxDragObject; const Point: TvxPoint);
begin
  // 
  if (Length(Data.Files) > 0) and FileExists(Data.Files[0]) and (Pos(ExtractFileExt(Data.Files[0]), DefaultFilterClass.GetFileTypes) > 0) then
  begin
    Preview.Fill.Bitmap.Bitmap.LoadFromFile(Data.Files[0]);
    Preview.UpdateEffects;
    Preview.Repaint;
    PreviewLayout.Repaint;
  end;
end;

procedure TForm11.Text3D1DragOver(Sender: TObject;
  const Data: TdxDragObject; const Point: TdxPoint; var Accept: Boolean);
begin
  Accept := (Length(Data.Files) > 0) and FileExists(Data.Files[0]) and (Pos(ExtractFileExt(Data.Files[0]), DefaultFilterClass.GetFileTypes) > 0);
end;

procedure TForm11.Text3D1DragDrop(Sender: TObject; const Data: TdxDragObject; const Point: TdxPoint);
begin
  TdxBitmapStream(dxBitmapList1.Bitmaps.Items[0]).Bitmap.LoadFromFile(Data.Files[0]);
end;

procedure TForm11.dxScene1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then
  begin
    Dummy1.RotateAngle.Z := Dummy1.RotateAngle.Z + (X - Down.X);
    Dummy2.RotateAngle.X := Dummy2.RotateAngle.X + (Y - Down.Y);
    Down := dxPoint(X, Y, 0);
  end;
end;

procedure TForm11.dxScene1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Down := dxPoint(X, Y, 0);
end;

procedure TForm11.PreviewDragOver(Sender: TObject;
  const Data: TvxDragObject; const Point: TvxPoint; var Accept: Boolean);
begin
  Accept := true;
end;

end.
